* EVAL_asm: extracted and adapted by Thierry Godefroy from "A mathematical and
*           graphical toolkit" by R.D. Harding, M. Lindroos and S. Sjberg (of
*           Chalmers university of technology - Gothenburg - Sweden).

          data      0
          section   EVAL

          LEA       TABLE,A1
          MOVEA.W   $110,A2
          JMP       (A2)

TABLE     dc.w      0
          dc.w      0
          dc.w      2
          dc.w      COMPIL-*
          dc.b      7,'COMPIL$'
          dc.w      EVAL-*
          dc.b      4,'EVAL',0
          dc.w      0

* COMPIL$ function, syntax: Compiled$=COMPIL$(Arithmetic_expression$)
*
* Arythmetic_expression$ may contain x, y and z variables, parenthesis, any
* valid S*BASIC operator (+,-,*,/,^), most of arythmetic functions (COS, ACOS,
* SIN, ASIN, TAN, ATAN, COT, ACOT, LN, LOG10, EXP, SQRT, ABS) as well as any
* numeric constant and PI (or ).

COMPIL    MOVEQ     #8,D0                         |
          ADD.L     A3,D0                         | Nombre de paramtres = 1 ?
          SUB.L     A5,D0                         |
          BNE       BADPAR                        Si non, erreur.
          BSR       GETVARADR                     Cherche l'adresse de chaine.
          MOVE.W    -2(A6,A0.L),D1                D1=longueur chaine
          SUBQ.W    #1,D1                         D1=D1-1 (compteur de boucle).
          MOVEA.L   A0,A3                         Adr. relative 1er caractre.
COMP01    MOVE.B    0(A6,A3.L),D0                 Code du caractre.
          CMPI.B    #'A',D0                       Caractre prcdant "A" ?
          BMI.S     COMP03                        Si oui caractre suivant.
          CMPI.B    #']',D0                       Caractre suivant "Z" ?
          BPL.S     COMP03                        Si oui caractre suivant.
          BSET      #5,0(A6,A3.L)                 Conversion en minuscule.
COMP03    ADDQ.L    #1,A3                         Pointer caractre suivant.
          DBRA      D1,COMP01                     Boucle jusqu' fin de chaine.
          MOVE.L    A4,D7                         Sauvegarde adresse fin chaine.
          MOVE.L    #212,D1                       | Rserver 212 octets sur
          BSR       MSRESV2                       |  la pile arithmtique.
          MOVEM.L   D1-D3/A0-A3,-(SP)             Sauvegarde du contexte.
          MOVEQ     #-1,D2                        Job courant.
          MOVEQ     #120,D1                       | Rserver 120 octets dans
          MOVEQ     #$18,D0                       |  le tas commun.
          TRAP      #1                            |
          MOVE.L    A0,A4                         A4=adresse zone alloue.
          MOVEM.L   (SP)+,D1-D3/A0-A3             Restitution du contexte.
          TST.L     D0                            Y-a-t'il une erreur ?
          BNE.S     COMP02                        Si oui retour avec erreur.
          MOVEA.L   A4,A5                         Sauvegarde de A4 dans A5.
          MOVEA.L   A4,A3                         Idem dans A3.
          ADDA.W    #$3E,A5
          MOVEQ     #$18,D4                       Pour ajuster longueur chaine.
          MOVEQ     #8,D0                         9 mots=3 nbres en virg. flot.
COMP04    SUBQ.L    #2,A1                         Ajuster pointeur de pile.
          CLR.W     0(A6,A1.L)                    Mise  0 des mots.
          DBRA      D0,COMP04                     Recommence pour mot suivant.
          SUBQ.L    #6,A1                         Rserver place pour nbre v.f.
          MOVE.L    #$6487ED51,2(A6,A1.L)         | Stockage de la
          MOVE.W    #$802,0(A6,A1.L)              |  valeur PI.
          BSR.S     COMP08                        Compilation de la chaine.
          BNE.S     COMP05                        Si erreur fin.
          LEA       2(A4,D5.L),A5                 Pointeur sur fin du tampon.
COMP09    SUBQ.L    #2,A1                         Ajuster A1.
          MOVE.W    -(A5),0(A6,A1.L)              | Transfert de la chaine
          CMPA.L    A4,A5                         |  dans la pile arithmtique.
          BHI.S     COMP09                        |
          ADD.W     D4,0(A6,A1.L)                 Ajuster longueur de la chaine.
          MOVE.L    A1,$58(A6)                    Mise  jour de BV.RIP.
          MOVEQ     #1,D4                         Paramtre retoun=chaine.
          MOVEQ     #0,D0                         Pas d'erreur.
COMP05    MOVE.L    D0,D6                         Sauvegarde du code d'erreur.
          MOVE.L    A1,-(SP)                      Sauvegarde du contexte.
          MOVEA.L   A3,A0                         Zone  librer.
          MOVEQ     #$19,D0                       | Libration de
          TRAP      #1                            |  la mmoire.
          MOVEA.L   (SP)+,A1                      Restitution du contexte.
          MOVE.L    D6,D0                         Restitution du code d'erreur.
COMP02    RTS                                     Retour au SuperBasic.

COMP08    MOVE.L    #$0FFF0FFF,-(SP)              Stocker valeur de repre.
          ADDQ.L    #2,A4                         Sauter mot de longueur chaine.
          MOVE.L    A4,D5                         Sauvegarde A4.
          MOVE.W    #'',(A4)+                   Caractres de marquage.
          BSR       COMP10                        | Compiler les codes
          BSR.S     COMP11                        |  opration.
          TST.B     D6                            Erreur ?
          BNE.S     COMP12                        Si oui dpilage et retour.
          CLR.B     (A4)+                         | Octets marqueurs de fin de
          CLR.B     (A4)+                         |  liste d'oprations.
          EXG       A4,D5                         A4=dbut de liste, D5=fin.
          SUB.L     A4,D5                         Longueur de la liste.
          BCLR      #0,D5                         Longueur rendue paire.
          MOVE.W    D5,-(A4)                      Stocker longueur de chaine.
          ADDQ.L    #4,SP                         Dpiler valeur de repre.
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.
COMP12    MOVEQ     #-17,D0                       Code erreur dans l'expression.
COMP13    CMPI.L    #$0FFF0FFF,(SP)+              Valeur de repre atteinte ?
          BNE.S     COMP13                        Si non, reboucler.
          TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

COMP11    CMPI.B    #$C,D6                        Opration - ?
          BNE.S     COMP14
          BSR       COMP10
          BSR.S     COMP15
          MOVE.B    #$14,(A4)+                    Opration NEG.
          BRA.S     COMP16
COMP14    CMPI.B    #$A,D6                        Opration + ?
          BNE.S     COMP53
          BSR       COMP10
COMP53    BSR.S     COMP15
COMP16    CMPI.B    #$A,D6                        Opration + ?
          BEQ.S     COMP17
          CMPI.B    #$C,D6                        Opration - ?
          BEQ.S     COMP17
          RTS
COMP17    MOVE.B    D6,-(A5)
          BSR       COMP10
          BSR.S     COMP15
          MOVE.B    (A5)+,(A4)+
          BRA.S     COMP16
COMP15    BSR.S     COMP18
COMP20    CMPI.B    #$E,D6                        Opration * ?
          BEQ.S     COMP19
          CMPI.B    #$10,D6                       Opration / ?
          BEQ.S     COMP19
          RTS
COMP19    MOVE.B    D6,-(A5)
          BSR.S     COMP10
          BSR.S     COMP18
          MOVE.B    (A5)+,(A4)+
          BRA.S     COMP20
COMP18    BSR.S     COMP21
COMP23    CMPI.B    #$30,D6                       Opration ^ ?
          BEQ.S     COMP22
          RTS
COMP22    MOVE.B    D6,-(A5)
          BSR.S     COMP10
          BSR.S     COMP21
          MOVE.B    (A5)+,(A4)+
          BRA.S     COMP23
COMP21    CMPI.B    #0,D6
          BEQ.S     COMP12
          CMPI.B    #-2,D6                        Fermeture parenthse ?
          BEQ.S     COMP12
          CMPI.B    #-1,D6                        Ouverture parenthse ?
          BNE.S     COMP24
          BSR.S     COMP10
          BSR       COMP11
          CMPI.B    #-2,D6                        Fermeture parenthse ?
          BNE       COMP12
          BSR.S     COMP10
          RTS
COMP24    TST.B     D6
          BPL.S     COMP52
          MOVE.B    D6,(A4)+
          BSR.S     COMP10
          RTS
COMP52    CMPI.B    #$10,D6                       Opration +, -, *, ou / ?
          BLS       COMP12
          CMPI.B    #$30,D6                       Opration ^ ?
          BEQ       COMP12
          MOVE.B    D6,-(A5)
          BSR.S     COMP10
          CMPI.B    #-1,D6                        Ouverture parenthse ?
          BNE       COMP12
          BSR.S     COMP10
          BSR       COMP11
          CMPI.B    #-2,D6                        Fermeture parenthse ?
          BNE       COMP12
          MOVE.B    (A5)+,(A4)+
COMP10    CMP.L     A0,D7
          BHI.S     COMP25
          MOVEQ     #0,D6
          RTS
COMP25    MOVE.B    0(A6,A0.L),D6                 Prendre 1er caractre.
          ADDQ.L    #1,A0                         Pointer caractre suivant.
          CMPI.B    #' ',D6                       Caractre = espace ?
          BEQ.S     COMP10                        Si oui, le sauter.
          SUBQ.L    #1,A0                         Pointer 1er caratre.
          CMPI.B    #'.',D6                       |
          BEQ.S     COMP28                        |
          CMPI.B    #'0',D6                       | Si le caractre est le dbut
          BCS.S     COMP30                        |  d'un nombre, le traiter,
          CMPI.B    #'9',D6                       |  sinon chercher oprateur.
          BLS.S     COMP28                        |
COMP30    LEA       OP_TABLE,A2                   Adresse table oprateurs.
          MOVE.L    A0,D1                         Sauvegarde de A0
COMP31    MOVE.L    A2,D2                         Sauvegarde de A2.
          MOVE.W    (A2)+,D0                      Longueur oprateur.
          BEQ       COMP12                        Si nulle, fin avec erreur.
          MOVEA.L   D1,A0                         Pointer dbut nom.
          SUBQ.W    #1,D0                         Ajuster D0 pour compteur DBRA.
COMP32    MOVE.B    0(A6,A0.L),D6                 Prendre un caractre du nom.
          ADDQ.L    #1,A0                         Pointer caractre suivant.
          CMP.B     (A2)+,D6                      Comparer noms.
          DBNE      D0,COMP32                     Si caractre idem reboucler.
          BNE.S     COMP33                        Si noms diffrents sauter.
          MOVE.B    (A2)+,D6                      Prendre code oprateur.
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.
COMP33    MOVEA.L   D2,A2                         Adresse oprateur.
          ADDA.W    (A2)+,A2                      Adresse code oprateur.
          ADDQ.L    #2,A2                         Sauter code+octet alignement.
          MOVE.L    A2,D2                         Dans registre data pour BCLR.
          BCLR      #0,D2                         Rendre adresse paire.
          MOVEA.L   D2,A2                         Adresse oprateur suivant.
          BRA.S     COMP31                        Traiter oprateur suivant.

COMP28    ADDQ.L    #6,D4
          MOVEA.W   $100,A2                       | Convertir nombre ASCII en
          JSR       (A2)                          |  nombre virgule flottante.
          TST.L     D0                            Erreur ?
          BNE       COMP13                        Si oui retour.
          MOVE.L    D4,D6
          NEG.L     D6
          RTS                                     Retour.

* Common subroutines.

GETVARADR MOVEQ     #-15,D0                       Code erreur mauvais paramtre.
          MOVE.W    0(A6,A3.L),D1                 D1=Mot "type de paramtre".
          ANDI.W    #$FF0F,D1                     Supprime type de sparateur.
          CMPI.W    #$201,D1                      Est-ce le nom d'une chaine ?
          BNE.S     EXIT                          Si non retour avec erreur.
          MOVEA.L   4(A6,A3.L),A0                 Offset chaine.
          ADDA.L    $28(A6),A0                    Ptr relatif  A6 sur chaine.
          ADDQ.L    #2,A0                         Adresse 1er caractre chaine.
          MOVEA.L   A0,A4                         Idem
          ADDA.W    -2(A6,A0.L),A4                Adr dernier caractre chaine.
          RTS                                     Retour.

GETFLTP   MOVEA.W   $114,A2
GETPAR    MOVEM.L   D1/D2/D4/D6/A0,-(SP)
          JSR       (A2)
          MOVEM.L   (SP)+,D1/D2/D4/D6/A0
          BNE.S     EXIT
          TST.W     D4
          BEQ.S     FIN
          MOVEQ     #-15,D0
          CMP.W     D3,D4
          BNE.S     EXIT
VOID      MOVEQ     #0,D0
FIN       RTS

EXIT      ADDQ.L    #4,SP
          RTS

BADPAR    MOVEQ     #-15,D0
          RTS

MSRESV    MOVE.L    A1,$58(A6)
MSRESV2   ADDQ.L    #1,D1
          BCLR      #0,D1
          MOVEM.L   D1-D3/A2,-(SP)
          MOVEA.W   $11A,A2
          JSR       (A2)
          MOVEM.L   (SP)+,D1-D3/A2
          MOVEA.L   $58(A6),A1
          RTS

* EVAL function, syntax: Result=EVAL([Error%,]Compiled$,x[,y[,z]])
*
* If Error% (MUST be an integer variable) is present, the function will return
* any arithmetic error code into it (this provides an easy way to trap errors
* with QLiberated programs). Else the function will report an error in the usual
* way.
* Compiled$ must be a compiled expression (see COMPIL$ function).
* x is mandatory and may be any floating point value, y and z are optional
* (this of course depends on how much variables were used in the COMPILed
* string).

EVAL      MOVEQ     #0,D5                         Pas de "variable erreur".
          MOVE.W    0(A6,A3.L),D1                 D1=Mot "type de paramtre".
          ANDI.W    #$FF0F,D1                     Supprime type de sparateur.
          CMPI.W    #$203,D1                      Est-ce un entier (mot) ?
          BNE.S     EVAL03                        Si non, sauter ce qui suit.
          MOVE.L    A3,D5                         Ptr pour "variable erreur".
          ADDQ.L    #8,A3                         Sauter paramtre.
EVAL03    ADDQ.L    #8,A3                         Sauter paramtre chaine.
          MOVEQ     #0,D4                         | Prendre un nbre indtermin
          BSR       GETFLTP                       |  paramtres virgule flott.
          MOVEQ     #-15,D0                       Code d'erreur "mauvais param".
          MOVE.W    D3,D4                         Sauver nombre paramtres v.f.
          BEQ.S     EVAL04                        Si pas de paramtre, erreur.
          SUBQ.W    #4,D3                         Plus de 3 paramtres ?
          BPL.S     EVAL04                        Si oui, erreur.
          SUBQ.L    #8,A3                         Restaurer pointeur 1er param.
          BSR       GETVARADR                     Prendre adr variable 1er para.
          CMPI.W    #'',0(A6,A0.L)              Est-ce une chaine COMPILe ?
          BNE.S     EVAL04                        Si non, retour avec erreur.
          SUBQ.W    #1,D4                         Ajuster D4 pour boucle DBRA.
          MOVEA.L   A4,A2                         Recopie du pointeur chaine.
EVAL01    MOVE.W    0(A6,A1.L),-6(A6,A2.L)        | Prendre le paramtre v.f.
          MOVE.L    2(A6,A1.L),-4(A6,A2.L)        |  et le stocker dans chaine.
          ADDQ.L    #6,A1                         Ajuster ptr pile arithmtique.
          SUBQ.L    #6,A2                         Ajuster pointeur chaine.
          DBRA      D4,EVAL01                     Prendre le paramtre suivant.
          MOVE.L    #256,D1                       | Rserver 256 octets sur
          BSR       MSRESV                        |  la pile arithmtique.
          MOVEQ     #0,D7                         RAZ D7 (bogue fonction EXP).
          MOVEA.W   $11E,A2                       Vecteur excution liste op.
          LEA       2(A6,A0.L),A3                 Ptr sur la liste d'oprations.
          JSR       (A2)                          Excuter liste d'oprations.
          MOVE.L    A1,$58(A6)                    Stocker valeur ptr pile arith.
          MOVEQ     #2,D4                         Valeur  retourner=nombre v.f.
EVAL02    TST.L     D5                            "Variable erreur" ?
          BEQ.S     EVAL04                        Si non, retour avec erreur.
          MOVEA.L   D5,A3                         Ptr pour "variable erreur".
          SUBQ.L    #2,A1                         Ajuster ptr de pile arithm.
          MOVE.L    A1,$58(A6)                    Stocker valeur ptr pile arith.
          MOVE.W    D0,0(A6,A1.L)                 Stocker code d'erreur.
          MOVE.L    D0,D7                         Sauver code d'erreur.
          MOVEA.W   $120,A2                       | Stocker le code d'erreur
          JSR       (A2)                          |  dans la "variable erreur".
          TST.L     D7                            Il y avait-t'il une Erreur ?
          BEQ.S     EVAL04                        Si non, retour avec rsultat.
          SUBQ.L    #2,A1                         Ajuster ptr de pile arithm.
          MOVE.L    A1,$58(A6)                    Stocker valeur ptr pile arith.
          CLR.W     0(A6,A1.L)                    Valeur  retourner = 0.
          MOVEQ     #3,D4                         Retourner un entier.
EVAL04    RTS                                     Retour.

OP_TABLE  dc.w      1
          dc.b      '+',$A
          dc.w      1
          dc.b      '-',$C
          dc.w      1
          dc.b      '*',$E
          dc.w      1
          dc.b      '/',$10
          dc.w      1
          dc.b      '^',$30
          dc.w      1
          dc.b      '(',-1
          dc.w      1
          dc.b      ')',-2
          dc.w      1
          dc.b      'x',-6
          dc.w      1
          dc.b      'y',-$C
          dc.w      1
          dc.b      'z',-$12
          dc.w      1
          dc.b      '',-$18
          dc.w      2
          dc.b      'pi',-$18,0
          dc.w      2
          dc.b      'ln',$2A,0
          dc.w      5
          dc.b      'log10',$2C
          dc.w      3
          dc.b      'exp',$2E
          dc.w      3
          dc.b      'abs',$12
          dc.w      3
          dc.b      'cos',$18
          dc.w      3
          dc.b      'sin',$1A
          dc.w      3
          dc.b      'tan',$1C
          dc.w      3
          dc.b      'cot',$1E
          dc.w      4
          dc.b      'asin',$20,0
          dc.w      4
          dc.b      'acos',$22,0
          dc.w      4
          dc.b      'atan',$24,0
          dc.w      4
          dc.b      'acot',$26,0
          dc.w      4
          dc.b      'sqrt',$28,0
          dc.w      0

          end
